---
sidebar_label: Welcome
---

# Roo Code Docs

Roo Code (formerly Roo Cline) is an AI-powered autonomous coding agent that lives in your editor. It helps you code faster and smarter, whether you're starting a new project, maintaining existing code, or learning new technologies.

## What Can Roo Code Do?

- 🚀 **Generate Code** from natural language descriptions
- 🔧 **Refactor & Debug** existing code
- 📝 **Write & Update** documentation
- 🤔 **Answer Questions** about your codebase
- 🔄 **Automate** repetitive tasks
- 🏗️ **Create** new files and projects

## Quick Start

1. [Install Roo Code](/getting-started/installing)
2. [Connect Your AI Provider](/getting-started/connecting-api-provider)
3. [Try Your First Task](/getting-started/your-first-task)

## Key Features

### Multiple Modes
Roo Code adapts to your needs with specialized [modes](/basic-usage/using-modes):
- **Code Mode:** For general-purpose coding tasks
- **Architect Mode:** For planning and technical leadership
- **Ask Mode:** For answering questions and providing information
- **Debug Mode:** For systematic problem diagnosis
- **Orchestrator Mode:** For managing complex tasks and delegating work
- **[Custom Modes](/features/custom-modes):** Create unlimited specialized personas for security auditing, performance optimization, documentation, or any other task

### Smart Tools
Roo Code comes with powerful [tools](/basic-usage/how-tools-work) that can:
- Read and write files in your project
- Execute commands in your VS Code terminal
- Control a web browser
- Use external tools via [MCP (Model Context Protocol)](/features/mcp/overview)

MCP extends Roo Code's capabilities by allowing you to add unlimited custom tools. Integrate with external APIs, connect to databases, or create specialized development tools - MCP provides the framework to expand Roo Code's functionality to meet your specific needs.

### Customization
Make Roo Code work your way with:
- [Custom Instructions](/features/custom-instructions) for personalized behavior
- [Custom Modes](/features/custom-modes) for specialized tasks
- [Local Models](/advanced-usage/local-models) for offline use
- [Auto-Approval Settings](/features/auto-approving-actions) for faster workflows

## Resources

### Documentation
- [Basic Usage Guide](/basic-usage/the-chat-interface)
- [Advanced Features](/features/auto-approving-actions)
- [Frequently Asked Questions](/faq)

### Community & Socials
- **Discord:** [Join our Discord server](https://discord.gg/roocode) for real-time help and discussions.
- **Reddit:** [Visit our subreddit](https://www.reddit.com/r/RooCode) to share experiences and tips.
- **GitHub:** Report [issues](https://github.com/RooVetGit/Roo-Code/issues) or request [features](https://github.com/RooVetGit/Roo-Code/discussions/categories/feature-requests?discussions_q=is%3Aopen+category%3A%22Feature+Requests%22+sort%3Atop).
- **X (Twitter):** [Follow @roo_code](https://x.com/roo_code).
- **Bluesky:** [Follow roocode.bsky.social](https://bsky.app/profile/roocode.bsky.social).
- **LinkedIn:** [Follow Roo Code](https://www.linkedin.com/company/roo-code).

Ready to get started? Click the **Next** button below to begin your journey with Roo Code!
